package meerkat.registry.AsyncRegistryCallbacks;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.protobuf.BulletinBoardAPI.BulletinBoardMessage;
import meerkat.registry.RegistryTags;

import java.util.List;

import static meerkat.util.BulletinBoardUtils.GetListOfTags;

// TODO : add logging

/**
 * Created by Vladimir Eliezer on 3/12/2016.
 * AsyncRegistry getGroups creates this callback to list of groups the voter in
 */
public class GetGroupsCallback implements FutureCallback<List<BulletinBoardMessage>> {
    protected FutureCallback<List<String>> callback;

    public GetGroupsCallback(FutureCallback<List<String>> callback){
        this.callback = callback;
    }

    @Override
    public void onSuccess(List<BulletinBoardMessage> messages) {
        callback.onSuccess(GetListOfTags(messages, RegistryTags.GROUP_ID_TAG));
    }

    @Override
    public void onFailure(Throwable t) {
        this.callback.onFailure(t);
    }
}
