package meerkat.registry.AsyncRegistryCallbacks;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.protobuf.BulletinBoardAPI.*;
import meerkat.protobuf.VoterRegistry;
import meerkat.registry.RegistryTags;

import java.util.List;

import static meerkat.util.BulletinBoardUtils.findTagWithPrefix;
import static meerkat.util.BulletinBoardUtils.getLatestMessage;

// TODO : add logging

/**
 * Created by Vladimir Eliezer  on 3/12/2016.
 * AsyncRegistry getVoter creates this callback to get voterInfo protobuff
 */
public class GetVoterCallback implements FutureCallback<List<BulletinBoardMessage>> {
    protected FutureCallback<VoterRegistry.VoterInfo> callback;

    public GetVoterCallback(FutureCallback<VoterRegistry.VoterInfo> callback){
        this.callback = callback;
    }

    @Override
    public void onSuccess(List<BulletinBoardMessage> messages) {
        BulletinBoardMessage latestMessage = getLatestMessage(messages);

        VoterRegistry.VoterInfo info = VoterRegistry.VoterInfo.newBuilder()
                .setId(VoterRegistry.VoterID.newBuilder()
                        .setId(findTagWithPrefix(latestMessage, RegistryTags.ID_TAG)))
                .setInfo(latestMessage.getMsg().getData().toStringUtf8()).build();

        callback.onSuccess(info);
    }

    @Override
    public void onFailure(Throwable t) {
        callback.onFailure(t);
    }
}
